<?php

namespace App\Filament\Exports;

use App\Models\WeightValidation;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class WeightValidationExporter extends Exporter
{
    protected static ?string $model = WeightValidation::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            // ExportColumn::make('id')
            //     ->label('ID'),
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
                ->label('PLANT'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('obd_number')
                ->label('OBD NUMBER'),
            ExportColumn::make('line_number')
                ->label('LINE NUMBER'),
            ExportColumn::make('batch_number')
                ->label('BATCH NUMBER'),
            ExportColumn::make('heat_number')
                ->label('HEAT NUMBER'),
            ExportColumn::make('obd_weight')
                ->label('ACTUAL WEIGHT'),
            ExportColumn::make('vehicle_number')
                ->label('VEHICLE NUMBER'),
            ExportColumn::make('bundle_number')
                ->label('BUNDLE NUMBER'),
            ExportColumn::make('picked_weight')
                ->label('PICKED WEIGHT'),
            ExportColumn::make('scanned_by')
                ->label('SCANNED BY'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your weight validation export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
